package musr.client.datacolumn;

import java.util.Date;

/**
 * A class that holds common Column Headers.
 * Similar column classes that extend this class (LinearColumn, ConcreteDataColumn, PoissonDataColumn, MultiColumn)
 * use this class to set their name (title) and the label (units).
 *
 * @author Ivan Tucakov, Nikola Tucakov
 */
public class ColumnHeader implements java.io.Serializable {

  static final long serialVersionUID = 0L; // SUID

    public String name;
    public String label;
    public String units;
    // Date is used to recognize the columns with an associated DataTable
    public Date date;


		// for potential later use
		//public String title;
		// history

		// Constructors
		public ColumnHeader() {	this("","","",new Date()); }
		public ColumnHeader(String name, String label, String units, Date date) {
				this.name = new String(name);
				this.label = new String(label);
                                                                                        this.units = new String(units);
                                                                                        this.date = date;
		}

		// Methods defined in DataColumn interface
		public final String getName() { return name; }
		public final String getLabel() { return label; }
		public final String getUnits() { return units; }
		public final Date getDate() { return date; }
		public final void setName(String name) { this.name = name; }
		public final void setLabel(String label) { this.label = label; }
		public final void setUnits(String units) { this.units = units; }
		public final void setDate(Date date) { this.date = date; }
}
