package musr.client.dbchecker;
import java.io.*;

public class DBDiagnosticConsole
{
    public static void main(String[] args)
    {
        try
        {
            BufferedReader inputStream = new BufferedReader(new InputStreamReader(System.in));
            System.out.println("DBDiagnostic\n\nThis program checks if files are valid, readable .db files with no formatting errors.\n" +
                    "Enter the filepath of the file to be tested, or enter a directory to test every file in that directory.\n");
            String filename = inputStream.readLine();
            File input = new File(filename);
            DBDiagnostic checker = new DBDiagnostic();
            
            if(input.isFile())
            {
                checker.setFile(input);
                checker.diagnose();
                System.out.println(checker.toString());
            }
            
            else if(input.isDirectory())
            {
                File[] fileHolder = input.listFiles();
                for(int i=0; i<fileHolder.length; i++)
                {
                    checker.reset();
                    checker.setFile(fileHolder[i]);
                    if((fileHolder[i].isFile())&&(!fileHolder[i].isHidden()))
                    {
                        checker.diagnose();
                        System.out.println(fileHolder[i].getName());
                        System.out.println(checker.toString() + "\n");
                    }
                }
            }
            
            else
                System.out.println("This is not a valid file.");
            
            inputStream.close();
        }
        catch(IOException e)
        {
            System.out.println("Error in console i/o.");
        }
        
        System.exit(0);
    }
}
