package musr.client.dbreader;

import java.awt.*;
import java.lang.*;
import java.util.*;
import musr.client.plot2d.Tools;
import musr.client.gui.*;

/**
 * Holds values for various functions
 *
 * @author Ivan Tucakov
 */
public class Functions implements Cloneable, java.io.Serializable {

  static final long serialVersionUID = 0L; // SUID

  // No Constructor

  /* Constants */

  public  Vector FUNCTION = new Vector();
  public  Vector FUNCTION_VALUE = new Vector();

  public Functions() {
    // Create all the default functions
/*    FUNCTION.addElement("c");
    FUNCTION_VALUE.addElement("300000");
    FUNCTION.addElement("e");
    FUNCTION_VALUE.addElement("2.17");
    FUNCTION.addElement("PI");
    FUNCTION_VALUE.addElement("3.14");*/
  }


  /**
   * Sets only the name for the new function
   */
  public void setFunction(String name) {
    int index = FUNCTION.indexOf(name);
    if (index == -1)  // if this function hasn't already been defined, put it in
      FUNCTION.addElement(name);
  }

  /**
   * Sets the two values for the new function, the name and the value
   */
  public void setFunction(String name, String value) {
    int index = FUNCTION.indexOf(name);
    if (index == -1) { // if this function hasn't already been defined, put it in
      FUNCTION.addElement(name);
      FUNCTION_VALUE.addElement(value);
    } else { // if it exists, replace it's value
      FUNCTION.set(index, name);
      FUNCTION_VALUE.set(index, value);
    }
  }
  /**
   * This is used to check whether the variable exists
   */
  public boolean functionExists(Frame parent, String name) {
    boolean result = false;
    for (int i=0; i<FUNCTION.size(); i++) {
      if (!((GUI)parent).caseMenuItem.getState()) {
        if (name.toUpperCase().equals(new String( (String)FUNCTION.get(i)).toUpperCase())) result=true;
      } else {
        if (name.equals(new String( (String)FUNCTION.get(i)))) result=true;
      }
    }
    return result;
  }
  /** Finds the new function value and returns it. If not found, it returns -1.*/
  public Object getFunctionValue(String name) {
    int index = FUNCTION.indexOf(name);
    if (index!=-1) return FUNCTION_VALUE.get(index);
    else return null;
  }
  /** Finds the new constant value and returns it. If not found, it returns -1.*/
  public Object getFunctionValue(int index) {
    return FUNCTION_VALUE.get(index);
  }
  /** Returns the size of the FUNCTION vector*/
   public int getSize() {return FUNCTION.size();}
  /** Returns the index of the first occurence of the object in the FUNCTION vector, if not there, return -1 */
  public int indexOf(String name) {return FUNCTION.indexOf(name);}
  /** Returns the element at the given index in the FUNCTION vector*/
   public Object getFunctionName(int index) {return FUNCTION.get(index);}

   public Object clone () throws CloneNotSupportedException {
      Functions returnValue = (Functions)super.clone();
      returnValue.FUNCTION = (Vector)FUNCTION.clone();
      //note: don't need to clone the Strings within the vetor.
      returnValue.FUNCTION_VALUE = (Vector)FUNCTION_VALUE.clone();
      return returnValue;
  }
}