package musr.client.gui;
import java.io.*;
import java.util.*;
import java.awt.*;
/**
* This class is used to clone Objects for Saving purposes. It makes a 'deep copy' of the Object
* (i.e. clones the Object and all the objects it contains) using serialization of Objects
* See: http://www.javaworld.com/javaworld/javatips/jw-javatip76.html
*/
                            public class ObjectCloner
                            {
                               // so that nobody can accidentally create an ObjectCloner object
                               private ObjectCloner(){}
                               // returns a deep copy of an object
                               static public Object deepCopy(Object oldObj) throws Exception
                               {
                                  ObjectOutputStream oos = null;
                                  ObjectInputStream ois = null;
                                  try
                                  {
                                     ByteArrayOutputStream bos =
                                           new ByteArrayOutputStream(); // A
                                     oos = new ObjectOutputStream(bos); // B
                                     // serialize and pass the object
                                     oos.writeObject(oldObj);   // C
                                     oos.flush();               // D
                                     ByteArrayInputStream bin =
                                           new ByteArrayInputStream(bos.toByteArray()); // E
                                     ois = new ObjectInputStream(bin);                  // F
                                     // return the new object
                                     return ois.readObject(); // G
                                  }
                                  catch(Exception e)
                                  {
                                     System.out.println("Exception in ObjectCloner = " + e);
                                     throw(e);
                                  }
                                  finally
                                  {
                                     oos.close();
                                     ois.close();
                                  }
                               }

                            }