package musr.client.gui;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import musr.client.datacolumn.*;

public class ViewColumnData
{
    private String[] columnName;
    private Double[][] data;
    public JFrame displayFrame;
    public Frame parentFrame;
    private int dataTableKey;
    private DataTable selectedDataTable;
    private int columnIndex;
    

    public ViewColumnData(Frame parent)
    {
        parentFrame = parent;
        dataTableKey = ((GUI)parentFrame).getDataTableIndex();
        Dictionary temp = ((GUI)parentFrame).dictionary;
        DataTable selectedDataTable = (DataTable)temp.getElement(dataTableKey);
        columnIndex = ((GUI)parentFrame).columnList.getSelectedIndex();
        
        DataColumn currentColumn = selectedDataTable.getColumn(columnIndex);
        
        columnName = new String[3];
        displayFrame = null;
        parentFrame = parent;
        
        columnName[0] = currentColumn.getName();
        columnName[1] = "Positive error";
        columnName[2] = "Negative error";
        
        data = new Double[currentColumn.getSize()][3];
        for(int i=0; i<currentColumn.getSize(); i++)
        {
                data[i][0] = new Double((((DataColumn)currentColumn).getValue(i)).toString());
                data[i][1] = new Double((((DataColumn)currentColumn).getErrorPlus(i)).toString());
                data[i][2] = new Double((((DataColumn)currentColumn).getErrorMinus(i)).toString());
        }
    }

    
    public void showTable()        //Actually displays the table
    {     
        JTable0 table = new JTable0(data, columnName);
        
        JScrollPane scrollPane = new JScrollPane(table);
        table.setPreferredScrollableViewportSize(new Dimension(500, 650));
        table.setGridColor(Color.DARK_GRAY);
        table.setShowGrid(true);
        table.setBackground(Color.LIGHT_GRAY);
        table.setIntercellSpacing(new Dimension(1,1));
        
        displayFrame = new JFrame();
        displayFrame.setSize(new Dimension(515, 675));
        displayFrame.setTitle(columnName[0]);
        displayFrame.getContentPane().setLayout(new BorderLayout());
        displayFrame.getContentPane().add(scrollPane, BorderLayout.CENTER);
        
        JButton closeButton = new JButton("Close");
        closeButton.addActionListener(new ActionListener0());
        displayFrame.getContentPane().add(closeButton, BorderLayout.SOUTH);
        displayFrame.addWindowListener(new WindowDestroyer0());
        
        displayFrame.setVisible(true);
    }
    
    public Double getValueAt(int row, int column)
    {
        return data[column][row];
    }
    
    public int getColumnCount()
    {
        return data.length;
    }
    
    public int getRowCount()
    {
        return data[0].length;
    }
    
    public String getColumnName(int column)
    {
        return columnName[column];
    }
    
    private class ActionListener0 implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
            if(e.getActionCommand().equals("Close"))
                displayFrame.dispose();
            else
                System.out.println("Error in user interface.");
        }
    }
    
    private class WindowDestroyer0 extends WindowAdapter
    {
        public void windowClosing(WindowEvent e)
        {
            displayFrame.dispose();
        }
    }
    
    private class JTable0 extends JTable
    {
        public JTable0(Object[][] data, String[] names)
        {
            super(data, names);
        }
        
        public boolean isCellEditable(int rowIndex, int columnIndex)
        {
            return false;
        }
    }
}