package musr.client.plot2d;
//import musr.client.datacolumn.*;
import musr.client.gui.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
//import java.awt.print.*;
import java.lang.*;
import javax.swing.*;
import java.util.*;

/**
 * This Class holds two types of components: buttons to 'manipulate' the graph and an Applet which is the graph itself.
 *
 * @author Ivan Tucakov, Nikola Tucakov
 */

public class Plot2D extends Panel implements java.io.Serializable {

  static final long serialVersionUID = 0L; // SUID
  Panel buttonsPanel;
  Button zoomButton;
  Button backButton;
  TextField xCoordinate;
  TextField yCoordinate;


  public PlotApplet plotApplet;

  /* Constructor method */
  public Plot2D(Frame parent, PlotOptionsFrame opFrame) {
    // Button will be put above the graph
    this.setLayout(new BorderLayout());


    // This is the zoom back feature button
    buttonsPanel = new Panel();
    buttonsPanel.setBackground(Color.white);
    buttonsPanel.setLayout(new GridBagLayout());
    GridBagConstraints gridConstr = new GridBagConstraints();
    // Some default values for the constranints object
    gridConstr.fill = GridBagConstraints.BOTH;
    gridConstr.insets = new Insets(5,5,5,5);
    gridConstr.anchor = GridBagConstraints.CENTER;

    zoomButton = new Button("Zoom In");
    backButton = new Button("Zoom Back");
    gridConstr.gridx = 0; gridConstr.gridy = 0;
    buttonsPanel.add(zoomButton,gridConstr);
    gridConstr.gridx = 1; gridConstr.gridy = 0;
    buttonsPanel.add(backButton,gridConstr);
    xCoordinate = new TextField(8);
    yCoordinate = new TextField(8);
    gridConstr.gridx = 2; gridConstr.gridy = 0;
    buttonsPanel.add(new Label("        x:"), gridConstr);
    gridConstr.gridx = 3; gridConstr.gridy = 0;
    buttonsPanel.add(xCoordinate, gridConstr);
    gridConstr.gridx = 4; gridConstr.gridy = 0;
    buttonsPanel.add(new Label("  y:"), gridConstr);
    gridConstr.gridx = 5; gridConstr.gridy = 0;
    buttonsPanel.add(yCoordinate, gridConstr);

    plotApplet = new PlotApplet(parent, opFrame, this);

    this.add(buttonsPanel, "North");

    this.add(plotApplet);

    // Mouse listeners for Zoom Features, when user wants to select the zoom area within the plot
    plotApplet.addMouseListener(plotApplet);
    plotApplet.addMouseListener(plotApplet);

    zoomButton.addActionListener(plotApplet);
    backButton.addActionListener(plotApplet);

  }

}
