package musr.client.plot2d;

/**
 * This class contains various methods that help in computation.
 *
 * @author Ivan Tucakov, Nikola Tucakov
 */
public class Tools implements java.io.Serializable {

  static final long serialVersionUID = 0L; // SUID
	// No Constructor

	/**
         * This method calculates the log with base 10 */
	public static double log10(double x) throws Exception {
		if (x<=0) Tools.fail("Error: use of Tool.log10 for non-positive value: "+x);
		double d = Math.log(x)/Math.log(10.0);
		return  d;
	}

	/**
         * This Method rounds a number to specified number of decimal points */
	public static double fraction(double d, int i) {
		return Math.round(Math.pow(10.00, (double) i) * d)
			/ Math.pow(10.00, (double) i);
	}


	/**
         * This Method converts Object data types to double */
	public static double objToDoub(Object o) {
		return Double.valueOf(String.valueOf(o)).doubleValue();
	}

	/**
         * This Method converts double data types to Object */
	public static Object doubToObj(double d) {
		return (Object)Double.toString(d);
	}

	/**
         * This Method converts Object data types to integer */
	public static int objToInt(Object o) {
		return Long.valueOf(String.valueOf(o)).intValue();
	}

	/**
         * This Method converts integer data types to Object */
	public static Object intToObj(int i) {
		return (Object)Long.toString(i);
	}

	/**
         * This method throws an exception */
	public static void fail(String msg) throws Exception {
		throw new Exception(msg);
	}

}
