package musr.client.spline;

/**
 *This class is used to hold x and y values for generating splines (which require calculations on both the x and y data values)
 */
public class Point
{
    public final double x;
    public final double y;
    
    /**
     *This constructor takes double values for x and y.
     */
    public Point(double newX, double newY)
    {
        x = newX;
        y = newY;
    }
    
    /**
     *This constructor takes values of type Object for x and y. Here they are assumed to be of the class Double - this is called when 
     *values are being taken from data columns, which require parsing and casting to extract the double value.
     */
    public Point(Object newX, Object newY)
    {
        x = Double.parseDouble(newX.toString());
        y = Double.parseDouble(newY.toString());
    }
}
