package musr.client.xml;
import musr.client.datacolumn.*;
import musr.client.function.*; //Ari's Function class is used in evaluateExpr(String)
import musr.client.gui.*;
import musr.client.plot2d.*;
import musr.client.dbreader.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.security.*;
import java.util.Date;

/**
 *
 */
public class XMLFileReader {

                /** This class contains and loads all the DatatTable variables and any other constants */
                private Constants dataTableVariables = new Constants();
                /** This class contains and loads 'custom' defined functions */
                private Functions functionsTable = new Functions();

                public Frame parent;  // This is the GUI where the console is called from

                /**
                 * Date is used to label the columns for future reference
                 */
                private Date date = new Date();

                /**
                 * This reader will be GLOBAL so that other methods can see it and use it. Note: it is assigned a value in the loadStream method
                 */
                 LineReader in;

                 String line;
                 String delimiters = " ";
                 StringTokenizer commandTokenizer;
                 String command = "";

                // This Dialog will contain one OK button and will be used for Displaying any kind of information,
                // error warnings or anything that would only have one OK button.
                Dialog infoDialog;
                Button OKButton = new Button("OK");
                // Event Listeners used
                private class ActionListenerS implements java.awt.event.ActionListener, java.io.Serializable {
                  public void actionPerformed(ActionEvent e) {}
                  };
                ActionListenerS buttonListener;

                public XMLFileReader(Frame paren, Constants dataTableVariables, Functions functionsTable) {
                  this.dataTableVariables = dataTableVariables;
                  this.functionsTable = functionsTable;
                  this.parent = paren;

                  infoDialog = new Dialog(parent,"", true);
                }



        /** Sets the Constant variables table*/
        public void setConstantsTable(Constants dataTableVariables) {this.dataTableVariables = dataTableVariables; }

        /** Sets the Functions table*/
        public void setFunctionsTable(Functions functionsTable) {this.functionsTable = functionsTable; }

        /** Set the case-INsensitivity for constant and column names ON or OFF*/
        public void setCaseSensitive(boolean set) {((GUI)parent).caseMenuItem.setState(set); }

      /**
      * Read the given stream and load the data into the class variables
      * I recommend looking up the file 'temp.db' (as an example) while going through this code
      **/
      public void loadStream(LineReader XMLin, String filepath) {
          // Set the GLOBAL value of the LineReader 'in'
          in = XMLin;

          try {
                // Handle events on the Buttons
                // Add/Removing Columns and their information in/from x-axis/y-axis Lists
                buttonListener = new ActionListenerS() {
                  public void actionPerformed(ActionEvent e) {
                    String command = ((Button)e.getSource()).getLabel();
                    if (command.equals("OK")) infoDialog.hide();
                  }
                };
                OKButton.addActionListener(buttonListener);


            // First, add a new datatable into the GUI
            // Create the DataTable that will be added into the GUI
            //---------------------------
            ((GUI)parent).tempDataColumns = new DataTable(filepath);
            //---------------------------

            // Load the data from the file
            // initialize line
            line = in.readLine();
            commandTokenizer = new StringTokenizer(line.trim(), "<>", false);
            while (line!=null) {
              // Assign the next command value
              assignNextCommand();

              if (command!=null) {
                if (command.trim().toUpperCase().equals("TITLE") ) {
                  assignNextCommand();
                  String tempTitle =  new String("");
                  while (command.trim().toUpperCase().indexOf("/TITLE")==-1) {
                    tempTitle += command;
                    assignNextCommand();
                  }
                  ((GUI)parent).tempDataColumns.setTitle(tempTitle);   // Put the title into (dataTable) !!
                }
                else if (command.trim().toUpperCase().equals("ABSTRACT")) {
                  assignNextCommand();
                  String tempAbstract = new String("");
                  while (command.trim().toUpperCase().indexOf("/ABSTRACT")==-1) {
                    tempAbstract += new String(command+"\n");
                    assignNextCommand();
                  }
                  ((GUI)parent).tempDataColumns.setAbstract(tempAbstract); // Put the abstract into (dataTable) !!
                }
                else if (command.trim().toUpperCase().equals("COMMENT")) {
                  assignNextCommand();
                  ((GUI)parent).tempRowDescription.clear(); // 'initialize' it
                  while (command.trim().toUpperCase().indexOf("/COMMENT")==-1) {
                    ((GUI)parent).tempRowDescription.add(command); // Read in the comments
                    assignNextCommand();
                  }
                  String tempComm = new String("");
                  for(int i=1; i<=((GUI)parent).tempRowDescription.size(); i++)
                    tempComm = tempComm.concat(i+") "+((GUI)parent).tempRowDescription.get(i-1)+"\n"); // Put all the comments into (dataTable) !!
                  ((GUI)parent).tempDataColumns.setComment(tempComm);
                }

                else if (command.trim().toUpperCase().equals("![CDATA[")) {
                  assignNextCommand();
                  ((GUI)parent).tempDataColumns.tableHistory.removeAll();
                  while (command.trim().indexOf("]]")==-1) {
                    ((GUI)parent).tempDataColumns.tableHistory.append(new String(command+"\n"));
                    assignNextCommand();
                  }
                }

                else if (command.trim().toUpperCase().equals("COLDEFNS")) {
                  assignNextCommand();
                  while (command.trim().toUpperCase().indexOf("/COLDEFNS")==-1) {
                    StringTokenizer colDefnsTokenizer = new StringTokenizer(command, "\"", false); // Note: the tokenizer will skip over quotation marks
                    colDefnsTokenizer.nextToken(); // Skip 'column type='
                    String tempType = colDefnsTokenizer.nextToken().trim(); // get the type
                    colDefnsTokenizer.nextToken(); // Skip ' name='
                    String tempName = colDefnsTokenizer.nextToken().trim(); // get the name
                    ((GUI)parent).tempNames.addElement(tempName);
                    colDefnsTokenizer.nextToken(); // Skip ' label='
                    String tempLabel = colDefnsTokenizer.nextToken().trim(); // get the label
                    ((GUI)parent).tempLabels.addElement(tempLabel);
                    if (tempType.toUpperCase().indexOf("VIRTUAL")!=-1) {
                        ((GUI)parent).tempDataColumns.addColumn( new LinearColumn(tempName, tempLabel, " ", 0, 0, 0, date));
                    } else if (tempType.toUpperCase().indexOf("REAL")!=-1) {
                        ((GUI)parent).tempDataColumns.addColumn( new MultiColumn(
                                                                              new ConcreteDataColumn(tempName, tempLabel, " ", date),
                                                                              new ConcreteDataColumn(),
                                                                              new ConcreteDataColumn()) );
                    }
                    assignNextCommand();
                  }
                }

                else if (command.trim().toUpperCase().equals("DATAROWS")) {
                  assignNextCommand();
                  while (command.trim().toUpperCase().indexOf("/DATAROWS")==-1) {
                    if (command.trim().toUpperCase().equals("VIRTUALDATA")) {
                      assignNextCommand();
                      while (command.trim().toUpperCase().indexOf("/VIRTUALDATA")==-1) {
                            StringTokenizer virtualDataTokenizer = new StringTokenizer(command, "\"", false); // Note: the tokenizer will skip over quotation marks
                            virtualDataTokenizer.nextToken(); // Skip 'var name='
                            String tempName = virtualDataTokenizer.nextToken().trim(); // get the name
                            virtualDataTokenizer.nextToken(); // Skip ' begin='
                            String tempBegin = virtualDataTokenizer.nextToken().trim(); // get the begin
                            ((LinearColumn) ((GUI)parent).tempDataColumns.getColumn(tempName)).begin=Double.parseDouble(tempBegin);
                            virtualDataTokenizer.nextToken(); // Skip ' step='
                            String tempStep = virtualDataTokenizer.nextToken().trim(); // get the Step
                            ((LinearColumn) ((GUI)parent).tempDataColumns.getColumn(tempName)).step=Double.parseDouble(tempStep);
                            virtualDataTokenizer.nextToken(); // Skip ' size='
                            String tempSize = virtualDataTokenizer.nextToken().trim(); // get the size
                            ((LinearColumn) ((GUI)parent).tempDataColumns.getColumn(tempName)).size=Integer.parseInt(tempSize);
                      assignNextCommand();
                      }
                    }
                    assignNextCommand();
                    if (command.trim().toUpperCase().equals("REALDATA")) {
                      assignNextCommand();
                      while (command.trim().toUpperCase().indexOf("/REALDATA")==-1) {
                        if (command.trim().toUpperCase().equals("ROW")) {
                          assignNextCommand();
                          while (command.trim().toUpperCase().indexOf("/ROW")==-1) {
                            StringTokenizer realDataTokenizer = new StringTokenizer(command, "\"", false); // Note: the tokenizer will skip over quotation marks
                            realDataTokenizer.nextToken(); // Skip 'var name='
                            String tempName = realDataTokenizer.nextToken().trim(); // get the name
                            realDataTokenizer.nextToken(); // Skip ' value='
                            String tempValue = realDataTokenizer.nextToken().trim(); // get the value
                            ((ConcreteDataColumn) ((MultiColumn)
                                               ((GUI)parent).tempDataColumns.getColumn(tempName)).getValueColumn() ).addElement(tempValue);
                            realDataTokenizer.nextToken(); // Skip ' posErr='
                            String tempPosErr = realDataTokenizer.nextToken().trim(); // get the posErr
                            ((ConcreteDataColumn) ((MultiColumn)
                                               ((GUI)parent).tempDataColumns.getColumn(tempName)).getErrorPlusColumn() ).addElement(tempPosErr);
                            realDataTokenizer.nextToken(); // Skip ' negErr='
                            String tempNegErr = realDataTokenizer.nextToken().trim(); // get the negErr
                            ((ConcreteDataColumn) ((MultiColumn)
                                               ((GUI)parent).tempDataColumns.getColumn(tempName)).getErrorMinusColumn() ).addElement(tempNegErr);

                            assignNextCommand();
                          }
                        }
                        assignNextCommand();
                      }
                    } // end: if REALDATA
                    assignNextCommand();
                  } // end: while /DATAROWS
                } // end: if DATAROWS
              } // end: if command!=null
            } // end: while loop

                  //---------------------
                  // Now add this DataTable into the GUI
                  ((GUI)parent).addDataTable(((GUI)parent).tempDataColumns, false, "");
                  // Reading the DataTable (otherwise it is not associated with it anymore)
                  ((GUI)parent).tempDataColumns = (DataTable) ((GUI)parent).dictionary.getElement( ((GUI)parent).dataTableList.getItemCount()-1 );
                  //---------------------


            // Once all the loading is done, reset the displays in the GUI DataTables Frame
            if (((GUI)parent).dataTableList.getItemCount()>0) {
              ((GUI)parent).dataTableList.select(((GUI)parent).dataTableList.getItemCount()-1); // Select the last item (which would be the datatable just loaded)
              ((GUI)parent).reloadColumnList();
            }

          } // end try

          // Display messages if something goes wrong
          catch (Exception e) {
            System.err.println("Error in XMLFileReader.LoadStream() Method: " + e.getMessage());
          }
      }


      /**
       * This command assigns the next Token to the variable command. It parses word by word.
       * It checks if the next command is '<!--' and if it is, it skips all the words until it reaches '-->'
       */
      private void assignNextCommand() {
          try {
              // If the previous call to assignNextCommand generated a command with '!--' (this happens if there are two '<!-- ... -->' commands in a row
              // then skip assigning of a new command and deal with this command with the code right after the code below
              if (command.indexOf("!--")==-1) {
                // assign the command
                setCommand();
              }
              // if there is a '<!--' skip words until '-->' reached
              // if it is not in this line, then load the new line
              if (command.indexOf("!--")!=-1) {
                command = command.substring(command.indexOf("!--")+3); //  Throw out the !-- part since we are about to search for "--" which is part of '-->'
//System.out.println("    command substring: "+command);
                // Search for '-->' until found
                while (command.indexOf("--")==-1) { // it doesn't contain it
                  // assign the command
                  setCommand();
                }
                // assign the command
                setCommand();
              }
//System.out.println("command: "+command);

          } // end try
          // Display messages if something goes wrong
          catch (Exception e) {
            System.err.println("Error in XMLFileReader.assignNextCommand() Method: " + e.getMessage());
          }
      }
      /**
       * This command assigns the next Token to the variable command.
       */
      private void setCommand() {
          try {
                // If there are no more tokens in this tokenizer, skip to the next line
//System.out.println("commandTokenizer.countTokens(): "+commandTokenizer.countTokens());
                if (commandTokenizer==null ||  !commandTokenizer.hasMoreTokens()) {
                  line = in.readLine();
//System.out.println("line: "+line);
                  if (line.trim().equals("")) line = in.readLine();
                  commandTokenizer = new StringTokenizer(line.trim(), "<>", false);
                }
                // Assign the command
                command = commandTokenizer.nextToken().trim();
          } // end try
          // Display messages if something goes wrong
          catch (Exception e) {
            System.err.println("Error in XMLFileReader.setCommand() Method: " + e.getMessage());
          }
      }
}
