package musr.server;

import java.io.*;
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.rmi.server.UnicastRemoteObject;
import java.security.*;

import musr.client.dbreader.FilePacket;

        /**
         * The musr GUI RMI server
         *
         * @author Ivan Tucakov
         */
        public class GUI_RMIServerImpl extends UnicastRemoteObject implements GUI_RMIServer {

            public GUI_RMIServerImpl() throws RemoteException {
                super();
            }

            public musr.client.dbreader.FilePacket senddbFile(String directory, String filename) {
              FilePacket packet = null;
              try {
              // This Creates the Object
              packet = new FilePacket( directory+filename );
                if ((filename == null) || (filename.length() == 0)) System.out.println("File name is invalid");
//System.out.println("loading file");
                // This reads the file into the object
                packet.readIn();
                                            /*  This code sets the security privileges for file opening
              		              try {
                                              inFile = (FileLineReader) AccessController.doPrivileged(
                                  new PrivilegedExceptionAction() {
                                                  public Object run() throws IOException {
              			              File f = new File(dir, file);           // Create a file object
                                                    return new FileLineReader(new FileReader(f));   // Create a stream to read
                                                  }
                                                }
                                              );
              		              }
                                            catch (PrivilegedActionException e) {
                                              throw (IOException) e.getException();
                                            }*/

              } catch (Exception e) {
                    System.out.println("GUI_RMIServerImpl file loading exception: " + e.getMessage());
                    e.printStackTrace();
              }
                return packet;

            }
/* This will be OK to erase but I am keeping it for reference use...
            public DataTable senddbURL(String URLname) {
                DBFileReader dbFileReader = new DBFileReader();
              try {
                dbFileReader.loadURL(URLname);         // load the data from the URL
              } catch (IOException ioe) {
                System.out.println(" # I/O Error in GUI_RMIServerImpl, " + ioe.getMessage() + ". \n"); }
            return dbFileReader.getDataTable(); // return the DataTable
            }
*/
            public static void main(String args[]) {

                // Create and install a security manager
                if (System.getSecurityManager() == null) {
                    System.setSecurityManager(new RMISecurityManager());
                }

                try {
                    GUI_RMIServerImpl obj = new GUI_RMIServerImpl();

                    // Bind this object instance to the name "GUI_RMIServer"

                    Naming.rebind("//musr.triumf.ca/GUI_RMIServer", obj);

                    System.out.println("GUI_RMIServer bound in registry");
                } catch (Exception e) {
                    System.out.println("GUI_RMIServerImpl err: " + e.getMessage());
                    e.printStackTrace();
                }
            }
        }