package musr.spect;

import java.awt.*;
import java.io.*;
import java.util.*;
import musr.client.plot2d.Tools;
import musr.spect.*;
import musr.client.gui.*;
import java.util.Date;


/**
 * This class
 */

public class LoadHistogram {

  public static MuSR_TDiHist main ( MUDSpectrumFrame mudSpectrumFrame, java.awt.List args, MuSR_Server srv, Date date, Frame parent )
    throws MuSR_Exception {
System.out.println("musr.spect.LoadHistogram:20");
      MuSR_TDhistRequest req = new MuSR_TDhistRequest();
      MuSR_TDiHist iH = new MuSR_TDiHist();

    try {

      int nArgs = args.getItemCount();

      if ( nArgs <= 3 ) {
	System.out.print("\n\n\tUsage:");
	System.out.print("\n\n \"java com.anm.musr.TestTDiH area year run jH i1 i2 np \""
			 +"\n\t to see Hist# jH bins i1-i2 packed by np");
	System.out.print("\n\n");
      }

      else {

// nArgs >= 2:  Packed MuSR_TDiHist dump for specified Histogram.
	String Ar = (String)args.getItem(0);  // Area
	int yr = Integer.parseInt(args.getItem(1)); // Year
	int iR = Integer.parseInt(args.getItem(2)); // Run
	int jH = 0; // Number (Spectrum Type)
	if ( nArgs > 3 ) jH = Integer.parseInt(args.getItem(3)) - 1;  // "H#1" is Histogram[0]
	int j1 = -1;
	if ( nArgs > 4 ) j1 = Integer.parseInt(args.getItem(4)) - 1;  // first bin;   "bin#1" is bin[0]
	int j2 = -1;  // "bin#1" is bin[0]
	if ( nArgs > 5 ) j2 = Integer.parseInt(args.getItem(5)) - 1;  // last bin;    (ditto)
	int np = 0;
	if ( nArgs > 6 ) np = Integer.parseInt(args.getItem(6)); // packing
	req.area = Ar;
	req.year = yr;
	req.run = iR;
	req.number = jH;
	req.firstBin = j1;
	req.lastBin = j2;
	req.packing = np;

//------------------------------------------
	iH = srv.getHistogram(req, mudSpectrumFrame, date, parent);
//------------------------------------------

	//	Vector values = new Vector();
/*
	System.out.print("\n" +iH.title);
	System.out.print("\nHistogram "+iH.histNumber+" [\""+iH.label+"\"]: ");
	System.out.print(iH.nBins +" bins");
	if ( iH.nsPerBin != 0.0 ) {
	  System.out.print(" of " +(float)iH.nsPerBin +" ns");
	}
	if ( iH.t1_ns != 0.0 ) {
	  System.out.print(" from "+(float)iH.t1_ns +" to "
			   +(float)iH.t2_ns +" ns");
	}
	System.out.print("\n");
	if ( iH.bkgdPerBin != 0.0 ) {
	  System.out.print(" t<0 background per bin = " +(float)iH.bkgdPerBin);
	}
    // First pbin is bin 0, but user should see "bin 1" as in FORTRAN:
	j1 = 0;
	j2 = iH.nnn.getSize() - 1;
	if ((j2>=j1) && (j1>=0)) {
	  System.out.print("\t  Bins ");
	  System.out.print((j1+1) +" to " +(j2+1) +":");
	  if (((j1+1)%10) != 1) Format.print(System.out, "\n % 6d: ", (j1+1));
	  for (int i=j1; (i<=j2); i++) {
	    if (((i+1)%10) == 1) {
	      Format.print(System.out, "\n % 6d: ", (i+1));
	    }
	    //	    values = iH.nnn.getValue(i);
	    int N = Tools.objToInt(iH.nnn.getValue(i));
	    Format.print(System.out, "% 7d", N);
	  }
	}
	System.out.print("\n");
*/
      }
    }

    catch (Exception e) {
      System.out.println("TestTDiH exception: " +
			 e.getMessage());
      e.printStackTrace();
    }
      System.out.println("musr.spect.LoadHistogram:103");
    return iH;
  }
}
