//: MuSR_Server.java

package musr.spect;

import musr.client.datacolumn.*;
import musr.client.gui.*;
import java.util.Date;

import java.io.*;
// import java.net.*;
import java.util.*;
import java.awt.*;

public class MuSR_Server {

  //    static String filebase="/home/tim/public_html/mud_td/data";

    static String filebase="/musr/data";

    public MuSR_Run run;  // One MuSR_Run object defined for all methods.
    String LastFile;  // Ditto last-called filename.

    public MuSR_Server() {
	run = new MuSR_Run(); // Construct the MuSR_Run obj. (initially = null)
	LastFile = new String();
    }

//////////////////////////////////////////////////////////////////////////////
// This method does all the real work of loading in the Run from a file:

  public MuSR_Run getRun(String arg)
    throws MuSR_Exception {

      if ( arg == LastFile ) {  // File already read into run.  Nothing to do.
	  return run; // Send back the existing result.
      }
      System.out.println("MuSR_Server:37");

    // OK, we have to read in a new data file.  Get to work!

    run = new MuSR_Run(); // Construct a new MuSR_Run obj. (initially = null)
    System.out.println("MuSR_Server:42");
    run.runHdr = new MuSR_RunHeader(); // Construct a fresh Run Header.

    run.runHdr.runNumber = 0; // Set the run# and # of hists to zero ...
    run.runHdr.nSclrs = 0; // ... and also the # of scalers ...
    run.runHdr.nHists = 0; // ... to signal failure without exiting.

    int i, j, k, l;
    int itb_fs, it0_ps, jt0_ps, it0_bin, ipwr;
    double tbns, t0ns;

    try {

      RandomAccessFile MuDfile = new RandomAccessFile (arg, "r");
      System.out.println("MuSR_Server:56");
      int lenTot = (int)(MuDfile.length());

      byte bb[] = new byte[lenTot];
      //      System.out.print(lenTot +" bytes read including 12-byte EOF. \n");

      MuDfile.read(bb); // Read in the whole file as bytes into bb.

      MuDfile.close();
      System.out.println("muSR_Server:65");
      /* ------------------------------------ Processing starts here: */

      int COREsize, secID, instanceID;
      String secIDname, instIDname;
      int jSclr = 0, jHist = 0, jIndVar = 0;
      int nGrp, memSize, totLen;
      int offset;
      int len;

      run.runHdr.fmtID = Byte2Int(8, bb); // (first instanceID)
      if ((run.runHdr.fmtID != 0x02010000) &
	  (run.runHdr.fmtID != 0x02020000)) throw new MuSR_Exception
		   ("Unknown MuD Format: "+arg);

      totLen = Byte2Int(0, bb) + Byte2Int(16, bb);
      //      System.out.print("looking for " +totLen +" bytes.\n");
System.out.println("muSR_Server:82");
      int loc = 0;
      while ((loc >= 0) && (loc < (totLen-1))) {
	COREsize = Byte2Int(loc, bb); loc = loc + 4;
	secID = Byte2Int(loc, bb); loc = loc + 4;
	instanceID = Byte2Int(loc, bb); loc = loc + 4;
	secIDname = MuD_SecType(secID);
	instIDname = MuD_InsType(instanceID);

	if (secID == 0x01010003) { // (MuD_SEC_GRP)
            System.out.println("MuSR_Server:92");
	  nGrp = Byte2Int(loc, bb); loc = loc + 4;
	  memSize = Byte2Int(loc, bb); loc = loc + 4;
	  if (instanceID == 0x02010000) { // [MuD_FMT_TRI_TD]
	  }
	  else if (instanceID == 0x02010004) { // [MuD_GRP_TRI_TD_SCALER]
	    run.runHdr.nSclrs = nGrp;
	    MuSR_Scaler scl[] = new MuSR_Scaler[run.runHdr.nSclrs];
	    for (i=0; i<run.runHdr.nSclrs; i++) {
	      scl[i] = new MuSR_Scaler();
	    } // (Does this create scl[i] or just a reference to it??)
	    run.sclr = scl; // Attach scaler array to run object.
	  }
          else if (instanceID == 0x01020005) { // [MuD_SEC_GEN_IND_VAR]
            run.runHdr.nIndVar = nGrp;
            MuSR_IndVar indv[] = new MuSR_IndVar[run.runHdr.nIndVar];
            for (i=0; (i<run.runHdr.nIndVar); i++) {
              indv[i] = new MuSR_IndVar();
            } // (Does this create IndVar[i] or just a reference to it??)
            run.indv = indv; // Attach indvar array to run object.
          }
	  else if (instanceID == 0x01020006) { // [Mix of IndVars & Arrays]
	    run.runHdr.nIndVar = nGrp/2;
	    MuSR_IndVar indv[] = new MuSR_IndVar[run.runHdr.nIndVar];
	    for (i=0; (i<run.runHdr.nIndVar); i++) {
	      indv[i] = new MuSR_IndVar();
	    } // (Does this create IndVar[i] or just a reference to it??)
	    run.indv = indv; // Attach indvar array to run object.
	  }
	  else if (instanceID == 0x02010002) { // [MuD_GPR_TRI_TD_HIST]
	    run.runHdr.nHists = nGrp/2;
	    MuSR_Histogram hst[] = new MuSR_Histogram[run.runHdr.nHists];
	    for (i=0; i<run.runHdr.nHists; i++) {
	      hst[i] = new MuSR_Histogram();
	    }
	    run.hist = hst; // Attach hist array to run object.
	  }
	  else if (instanceID == 0x02020002) { // [MuD_GPR_TRI_TI_HIST]
// NOTE: TI mode "hists" are NOT REALLY HISTOGRAMS but plain integer arrays!
// Nevertheless we shall use "Hist" methods to manipulate them here.
// Just don't get this mixed up in any external procedures!
	    run.runHdr.nHists = nGrp/2;
	    MuSR_Histogram hst[] = new MuSR_Histogram[run.runHdr.nHists];
	    for (i=0; i<run.runHdr.nHists; i++) {
	      hst[i] = new MuSR_Histogram();
	    }
	    run.hist = hst; // Attach hist array to run object.
	  }

	  for ( j=0; j<nGrp; j++ ) {
	    offset = Byte2Int(loc, bb); loc = loc + 4;
	    secID = Byte2Int(loc, bb); loc = loc + 4;
	    instanceID = Byte2Int(loc, bb); loc = loc + 4;
	  }
	}
	else if (secID == 0x01020001) { // (MuD_SEC_GEN_RUN_DESC)
            System.out.println("muSR_Server:148");
	  run.runHdr.exptNumber = Byte2Int(loc, bb); loc = loc + 4;
	  run.runHdr.runNumber = Byte2Int(loc, bb); loc = loc + 4;
	  run.runHdr.timeBegin = Byte2Int(loc, bb); loc = loc + 4;
	  run.runHdr.timeEnd = Byte2Int(loc, bb); loc = loc + 4;
	  run.runHdr.elapsedSec = Byte2Int(loc, bb); loc = loc + 4;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.title = ChStr2String (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.lab = ChStr2String (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.area = ChStr2String (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.method = ChStr2StringMu (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.apparatus = ChStr2String (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.insert = ChStr2String (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.sample = ChStr2String (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.orient = ChStr2String (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.das = ChStr2String (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.experimenter = ChStr2String (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.temperature = ChStr2String (loc, len, bb); loc = loc + len;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.runHdr.field = ChStr2String (loc, len, bb); loc = loc + len;
	}
        else if (secID == 0x02020001) { // (MuD_SEC_TI_RUN_DESC)
            System.out.println("muSR_Server:180");
          run.runHdr.exptNumber = Byte2Int(loc, bb); loc = loc + 4;
          run.runHdr.runNumber = Byte2Int(loc, bb); loc = loc + 4;
          run.runHdr.timeBegin = Byte2Int(loc, bb); loc = loc + 4;
          run.runHdr.timeEnd = Byte2Int(loc, bb); loc = loc + 4;
          run.runHdr.elapsedSec = Byte2Int(loc, bb); loc = loc + 4;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.title = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.lab = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.area = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.method = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.apparatus = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.insert = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.sample = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.orient = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.das = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.experimenter = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.subtitle = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.comment1 = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.comment2 = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.runHdr.comment3 = ChStr2String (loc, len, bb); loc = loc + len;
        }
	else if (secID == 0x01020002) { // (MuD_SEC_GEN_HIST_HDR){
            System.out.println("muSR_Server:216");
	  run.hist[jHist].histNumber = instanceID;
	  run.hist[jHist].histType = Byte2Int(loc, bb); loc = loc + 4;
	  run.hist[jHist].nBytes = Byte2Int(loc, bb); loc = loc + 4;
	  run.hist[jHist].nBins = Byte2Int(loc, bb); loc = loc + 4;
	  run.hist[jHist].bytesPerBin = Byte2Int(loc, bb); loc = loc + 4;

	  if (run.hist[jHist].histType == 0x02010002) {  // TD format...
// Default: take nominal nsPerBin, t0_ns and t0_bin :
	    itb_fs = Byte2Int(loc, bb); loc = loc + 4;
	    run.hist[jHist].nsPerBin = (double)(itb_fs)/1000000.0;
	    it0_ps = Byte2Int(loc, bb); loc = loc + 4;
	    run.hist[jHist].t0_ns = (double)(it0_ps)/1000.0;
	    it0_bin = Byte2Int(loc, bb); loc = loc + 4;
	    run.hist[jHist].t0_bin = it0_bin;
// Check for "BNC encoded" fsPerBin :
	    if (itb_fs <= 27) { // decode BNC fsPerBin
	      ipwr = itb_fs - 16;
	      tbns = 0.048828125*DtoI(2.0,ipwr); // true nsPerBin!
	      t0ns = (double)(it0_bin)*run.hist[jHist].nsPerBin;
	      jt0_ps = (int)(t0ns*1000.0);  // nominal (miscalculated) value
	      if (jt0_ps == it0_ps) {  // we've been stupid; fix t0_bin too.
		run.hist[jHist].t0_ns = (double)(it0_bin)*tbns;
	      }  // (Don't modify t0_ps if it is not bogus!)
	      run.hist[jHist].nsPerBin = tbns;  // Corrected fsPerBin
	    }
	  }
//	  else if (run.hist[jHist].histType == 0x02020002) {  // TI format...
	  else { // Any other format: just take int values literally.
// NOTE: TI mode "hists" are NOT REALLY HISTOGRAMS but plain integer arrays!
// Nevertheless we shall use "Hist" methods to manipulate them here.
// Just don't get this mixed up in any external procedures!
	    itb_fs = Byte2Int(loc, bb); loc = loc + 4;
	    run.hist[jHist].nsPerBin = (double)(itb_fs);
	    it0_ps = Byte2Int(loc, bb); loc = loc + 4;
	    run.hist[jHist].t0_ns = (double)(it0_ps);
	    it0_bin = Byte2Int(loc, bb); loc = loc + 4;
	    run.hist[jHist].t0_bin = it0_bin;
	  }

	  run.hist[jHist].goodBin1 = Byte2Int(loc, bb); loc = loc + 4;
	  run.hist[jHist].goodBin2 = Byte2Int(loc, bb); loc = loc + 4;
	  run.hist[jHist].bkgd1 = Byte2Int(loc, bb); loc = loc + 4;
	  run.hist[jHist].bkgd2 = Byte2Int(loc, bb); loc = loc + 4;
	  run.hist[jHist].nEvents = Byte2Int(loc, bb); loc = loc + 4;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.hist[jHist].title = ChStr2String (loc, len, bb); loc = loc + len;
//System.out.println("(int) (run.hist[jHist].nBins+1): "+(int) run.hist[jHist].nBins+1);
	  run.hist[jHist].bin = new int[(run.hist[jHist].nBins+1)];

	}
	else if (secID == 0x01020003) { // (MuD_SEC_GEN_HIST_DAT)
System.out.println("muSR_Server:268");
	    if (run.hist[jHist].histType == 0x02010002) {  // TD format...
		run.hist[jHist].unPack(loc, bb); // Unpack the Histogram!
                System.out.println("muSR_Server:271");
		loc = loc + run.hist[jHist].nBytes + 4;
	    }

	    else if (run.hist[jHist].histType == 0x02020002) {  // TI format...
// NOTE: TI mode "hists" are NOT REALLY HISTOGRAMS but plain integer arrays!
// Nevertheless we shall use "Hist" methods to manipulate them here.
// Just don't get this mixed up in any external procedures!
		loc = loc + 4;
		run.hist[jHist].unPack(loc, bb); // Unpack the Histogram!
		loc = loc + run.hist[jHist].nBytes;
	    }

	    jHist++;

	}
	else if (secID == 0x01020004) { // (MuD_SEC_GEN_SCALER)
            System.out.println("muSR_Server:287");
	  run.sclr[jSclr].sclrNum = instanceID;
	  run.sclr[jSclr].totalCount = Byte2Int(loc, bb); loc = loc + 4;
	  run.sclr[jSclr].lastCount = Byte2Int(loc, bb); loc = loc + 4;
	  len = ChStrLen(loc, bb); loc = loc + 2;
	  run.sclr[jSclr].label = ChStr2String (loc, len, bb); loc = loc + len;
	  jSclr++;
	}
        else if (secID == 0x01020005) { // (MuD_SEC_GEN_IND_VAR)
            System.out.println("muSR_Server:296");
          run.indv[jIndVar].IndVarNum = instanceID;
          run.indv[jIndVar].low = Byte2Dbl(loc, bb); loc = loc + 8;
          run.indv[jIndVar].high = Byte2Dbl(loc, bb); loc = loc + 8;
          run.indv[jIndVar].mean = Byte2Dbl(loc, bb); loc = loc + 8;
          run.indv[jIndVar].stddev = Byte2Dbl(loc, bb); loc = loc + 8;
          run.indv[jIndVar].skew = Byte2Dbl(loc, bb); loc = loc + 8;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.indv[jIndVar].name = ChStr2String (loc, len, bb); loc = loc + len;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.indv[jIndVar].descr = ChStr2String (loc, len, bb); loc = loc + len
;
          len = ChStrLen(loc, bb); loc = loc + 2;
          run.indv[jIndVar].units = ChStr2String (loc, len, bb); loc = loc + len
;
          jIndVar++;
        }
	else if (secID == 0x01020007) { // (MuD_SEC_GEN_ARRAY)
            System.out.println("muSR_Server:314");
	  i = Byte2Int(loc, bb); loc = loc + 4;
	  j = Byte2Int(loc, bb); loc = loc + 4;
	  k = Byte2Int(loc, bb); loc = loc + 4;
	  l = Byte2Int(loc, bb); loc = loc + 4;
	  l = Byte2Int(loc, bb); loc = loc + 4;
	  loc = loc + l;  // Just skip over it for now.
	}
	else if (secID == 0x01010004) { // (MuD_SEC_EOF)
            System.out.println("muSR_Server:323");
	  loc = lenTot;
	  break;
	}

	else {
	}
      }
      System.out.println("MuSR_Server:323");
    }

    catch (IOException e) { // if unable to read file...
      //      System.out.print("IO Error: "+e);
      //      System.exit(1);
      throw new MuSR_Exception ("I/O error on "+arg);
    }

    /*
    catch (MuSR_FormatException e) { // if wrong type of file...
      //      System.out.print("MuD Format Error: "+e);
      //      System.exit(1);
      throw new MuSR_Exception
		   ("Wrong Format: "+arg); // (wrong type)
    }
    */

    catch (MuSR_PackingException e) { // if wrong type of hist packing...
      //      System.out.print("MuD Histogram Packing Error: "+e);
      //      System.exit(1);
      throw new MuSR_Exception ("Hist unPacking error on "+arg);
    }

    LastFile = arg;  // Mark this file as "current run".

    return run; // Send back the final result.

  }

////////////////////////////////////////////////////////////////////////////
/* Some private methods: */

  static String MuD_LabID ( int ID ) {
    switch ((ID&0x07000000)) {
    case 0x01000000: return "ALL";
    case 0x02000000: return "TRI";
    case 0x03000000: return "RAL";
    case 0x04000000: return "PSI";
    default: return "UNKNOWN LabID";
    }
  }

  static String MuD_FmtID ( int ID ) {
    switch ((ID&0x07070000)) {
    case 0x01010000: return "ALL";
    case 0x01020000: return "GEN";
    case 0x02010000: return "TRI_TD";
    case 0x02020000: return "TRI_TI";
    default: return "UNKNOWN FmtID";
    }
  }

  static String MuD_AllID ( int ID ) {
    switch ((ID&0x07000000)) {
    case 0x01000000: return "ALL";
    case 0x02000000: return "TRI";
    case 0x03000000: return "RAL";
    case 0x04000000: return "PSI";
    default: return "UNKNOWN AllID";
    }
  }

  static String MuD_SecType ( int secID ) {
    switch (secID) {
    case 0x01010003: return "MuD_SEC_GRP";
    case 0x01020001: return "MuD_SEC_GEN_RUN_DESC";
    case 0x01020002: return "MuD_SEC_GEN_HIST_HDR";
    case 0x01020003: return "MuD_SEC_GEN_HIST_DAT";
    case 0x01020004: return "MuD_SEC_GEN_SCALER";
    case 0x01020005: return "MuD_SEC_GEN_IND_VAR";
    case 0x01020007: return "MuD_SEC_GEN_ARRAY";
    case 0x01010004: return "MuD_SEC_EOF";
    case 0x02020001: return "MuD_SEC_TI_RUN_DESC";
    default: return "UNKNOWN secID";
    }
  }

  static String MuD_InsType ( int instID ) {
    switch (instID) {
    case 0x02010000: return "MuD_FMT_TRI_TD";
    case 0x02010002: return "MuD_SEC_TRI_TD_HIST";
    case 0x02010004: return "MuD_GRP_TRI_TD_SCALER";
    case 0x02020000: return "MuD_FMT_TRI_TI";
    case 0x02020002: return "MuD_SEC_TRI_TI_HIST";
    case 0x02020004: return "MuD_GRP_TRI_TI_SCALER";
    default: return("Instance # "+instID);
    }
  }

  static short Byte2Short ( int loc, byte b[] ) {
    short m1, m2;
    m1 = (short)(b[loc]); if (m1<0) m1=(short)(256+m1);
    m2 = (short)(b[loc+1]); if (m2<0) m2=(short)(256+m2);
    m2 = (short)(256*m2 + m1);
    return m2;
  }

  static int Byte2Int ( int loc, byte b[] ) {
    int i1, i2, i3, i4;
    i1 = (int)(b[loc]); if (i1<0) i1=(int)(256+i1);
    i2 = (int)(b[loc+1]); if (i2<0) i2=(int)(256+i2);
    i3 = (int)(b[loc+2]); if (i3<0) i3=(int)(256+i3);
    i4 = (int)(b[loc+3]); if (i4<0) i4=(int)(256+i4);
    i4 = (int)(16777216*i4 + 65536*i3 + 256*i2 + i1);
    return i4;
  }

  static long Byte2Long ( int loc, byte b[] ) {
    int shift;
    long kk, jj = 0;
    shift = 0;
    for (int i=0; i<8; i++) {
      kk = (long)(b[loc+i]); if (kk<0) kk=256+kk;
      kk = (kk << shift);
      jj = jj + kk;
      shift = shift + 8;
    }
    return jj;
  }

  static double Byte2Dbl ( int loc, byte b[] ) {
    double xx;
    long bits, lexp;
    boolean minus;
    int ib, shift;
    byte by[] = new byte[8];
    byte bt;
    //    System.out.print("\n\tbytes in: ");
    for (int i=0; i<8; i++) {  // Read in 8 bytes.
      by[7-i] = b[loc+i];  // Reverse nominal order.
      //      ib = (int) b[loc+i]; if (ib<0) ib=256+ib;
      //      System.out.print(Long.toHexString(ib)+" ");
    }
// Reassemble bytes in bizarre DEC order (exchange even and odd bytes!)
    bt=by[0]; by[0]=by[1]; by[1]=bt;
    bt=by[2]; by[2]=by[3]; by[3]=bt;
    bt=by[4]; by[4]=by[5]; by[5]=bt;
    bt=by[6]; by[6]=by[7]; by[7]=bt;
    bits = Byte2Long(0, by);  // Now make a long out of it.
// Should now have a semi-rational bit order.
    //    System.out.print("\n\t|long|  in (hex) = "+Long.toHexString(bits));
    //    minus = ((bits >> 63) == 1);  // THIS DOES NOT WORK! (????)
    minus = (by[7] < 0);  // Check for sign bit.
    bits = (bits & 0x7fffffffffffffffL); // Strip off sign bit.
    lexp = (bits >> 55);   //  Get VMS real*8 exp.
    lexp = (lexp & 0xffL);  // Mask VMS real*8 exp (8 bits).
    //    System.out.print("\n\texp: VMS = "+Long.toHexString(lexp));
    lexp = lexp - 128;  // Get actual exponent from VMS exp.
    //    System.out.print("\ttrue (dec) = "+lexp);
// 1022 should be 1024 in the next line, but this works!!
    lexp = lexp + 1022;  // Convert to IEEE 754 exponent.
    lexp = (lexp & 0x7ffL);  // Mask IEEE exp (11 bits).
    //    lexp = ((lexp << 52) & 0x7ff0000000000000L);  // Position exponent.
    lexp = (lexp << 52);  // Position exponent.
    //    System.out.print("\tIEEEE = "+Long.toHexString(lexp));
    bits = (bits & 0x007fffffffffffffL);  // Get VMS 55 bit mantissa.
    bits = (bits >> 3);  // Push out lowest 3 bits of mantissa.
    bits = (bits & 0x000fffffffffffffL);  // Keep 52 bit mantissa.
    bits = bits | lexp;  // Combine exp and mantissa.
    shift = 0;  // Now reverse byte order.
    for (int i=0; i<8; i++) {
      by[i] = (byte)((bits >> shift) & 0xffL);
      shift = shift + 8;
    }
    bits = Byte2Long(0, by);  // Make a long out of swapped bytes.
    //    System.out.print("\n\t|long| out (hex) = "+Long.toHexString(bits));
    xx = Double.longBitsToDouble(bits);  // Decode IEEE 754 double.
    if (minus) xx = -xx;  // Replace sign bit if needed.
    //    System.out.print("\n\tDouble "+X.doubleValue());
    return xx;
  }

  static int ChStrLen ( int loc, byte b[] ) {
    int i = (int)(Byte2Short(loc, b));
    return i;
  }

  static String ChStr2String ( int loc, int len, byte b[] ) {
    StringBuffer sb = new StringBuffer(len);
    for ( int i=loc; i<(loc+len); i++ ) {
      sb.append((char)(b[i]));
    }
    return sb.toString();
  }

  static String ChStr2StringMu ( int loc, int len, byte b[] ) {
    StringBuffer sb = new StringBuffer(len);
    byte mu = (byte)181; // 0xB5;
    char Umu = '\u03BC';
    for ( int i=loc; i<(loc+len); i++ ) {
      if (b[i] == mu) sb.append(Umu);
      else sb.append((char)(b[i]));
    }
    return sb.toString();
  }

  // Stupid Java doesn't have a ** or ^ operator for simple integer powers!
  static double DtoI ( double D, int I ) {
    double X = 1.0;
    if (I==0) {
      X = 1.0;
    }
    else if (I>0) {
      for ( int i=I; i>0; i-- ) {
        X = X*D;
      }
    }
    else if (I<0) {
      for ( int i=I; i<0; i++ ) {
        X = X/D;
      }
    }
    return X;
  }

//////////////////////////////////////////////////////////////////////////////
// Now come the methods to extract and return specific components from "run"

//-----------------------------------------------------------------------------
/* method to load up the run and return only its RunHeader info */

  public MuSR_RunHeader getRunHdr(String arg)
  throws MuSR_Exception {
    System.out.println("MuSR_Server:545");
    run = getRun(arg); // Load it all in (if needed).
    System.out.println("MuSR_Server:547");
    return run.runHdr;

  }

//-----------------------------------------------------------------------------
/* method to load up the run and return one Scaler */

  public MuSR_Scaler getScaler(String args[])
  throws MuSR_Exception {

    run = getRun(args[0]); // Load it all in (if needed).

    int jSclr = Long.valueOf(args[1]).intValue() - 1;

    return run.sclr[jSclr];

  }

//-----------------------------------------------------------------------------
/* method to load up the run and return one Independent Variable */

  public MuSR_IndVar getIndVar(String args[])
  throws MuSR_Exception {

      //    MuSR_Run run = new MuSR_Run(); // Create ref to new MuSR_Run obj.

    run = getRun(args[0]); // Load it all in (if needed).

    int jIndVar = Long.valueOf(args[1]).intValue() - 1;

    return run.indv[jIndVar];

  }

//-----------------------------------------------------------------------------
/* method to load up the run and return one Histogram */

  public MuSR_Histogram getHist(String args[])
  throws MuSR_Exception {

      //    MuSR_Run run = new MuSR_Run(); // Create ref to new MuSR_Run obj.

    run = getRun(args[0]); // Load it all in (if needed).

    int jHist = Long.valueOf(args[1]).intValue() - 1;

    return run.hist[jHist];

  }

//-----------------------------------------------------------------------------
/* method to load up the run and return one HistHdr */

  public MuSR_HistHdr getHistHdr(String args[])
  throws MuSR_Exception {

      //    MuSR_Run run = new MuSR_Run(); // Create ref to new MuSR_Run obj.

    run = getRun(args[0]); // Load it all in (if needed).

    MuSR_HistHdr hstHdr = new MuSR_HistHdr();
    int jHist = Long.valueOf(args[1]).intValue() - 1;
    hstHdr = run.hist[jHist].getHdr();

    return hstHdr;

  }

//-----------------------------------------------------------------------------
/* method to load up the run and return ALL its header info */

  public MuSR_Headers getHeaders(String arg) {

    MuSR_Headers Hdrs = new MuSR_Headers(); // Create ref to new Headers obj.

    try {

//---------------------
      run = getRun(arg); // Load it all in (if needed).
//---------------------

    }

    catch (MuSR_Exception e) {
      System.out.println("getHeaders error: "+e);
      //      System.exit(1);
    }

    Hdrs.runHdr = run.runHdr; // Attach RunHeader to Headers object.

    MuSR_Scaler scl[] = new MuSR_Scaler[run.runHdr.nSclrs];
    for (int i=0; i<run.runHdr.nSclrs; i++) {
	scl[i] = run.sclr[i];
    }
    Hdrs.sclr = scl; // Attach scaler array to Headers object.

    MuSR_HistHdr hHdr[] = new MuSR_HistHdr[run.runHdr.nHists];

    for (int i=0; i<run.runHdr.nHists; i++) {
      hHdr[i] = run.hist[i].getHdr();
    }
    Hdrs.histHdr = hHdr; // Attach HistHdr array to Headers object.

    return Hdrs;

  }


//-----------------------------------------------------------------------------
/* method to return a MuSR_TDiHist (integer Histogram) object from a TD MuSR_Run */

  public MuSR_TDiHist getHistogram(MuSR_TDhistRequest reqInfo, MUDSpectrumFrame mudSpectrumFrame, Date date, Frame parent) {

    MuSR_TDiHist iH = new MuSR_TDiHist(); // Create ref to new MuSR_TDiHist obj.
    int pbin[]; // Array of packed integer bins.
    String fnm="";

    try {

//--------------------- Construct filespec:  (site dependent!)

    if (reqInfo.year==0 && reqInfo.run==0) { // this means that the full path is in the reqInfo.area
      fnm = reqInfo.area;
    } else {
      fnm = reqInfo.run+".msr";
      if ( reqInfo.run < 100000 ) fnm = "0"+fnm;
      if ( reqInfo.run < 10000 ) fnm = "0"+fnm;
      if ( reqInfo.run < 1000 ) fnm = "0"+fnm;
      if ( reqInfo.run < 100 ) fnm = "0"+fnm;
      if ( reqInfo.run < 10 ) fnm = "0"+fnm;
      fnm = filebase+"/"+reqInfo.area.toLowerCase()
	            +"/"+reqInfo.year+"/"+fnm;
    }

//---------------------
      run = getRun(fnm); // Load it all in (if needed).
//---------------------

      // Get the Run Number
      iH.runNumber = run.runHdr.runNumber;     // Run number

      // Get the Histogram number
      if (reqInfo.number<0) reqInfo.number = 0;  // Actual Histograms are numbered from 0.
// Make sure the user interface subtracts 1 from "Histogram Number"!
      if (reqInfo.number>=run.runHdr.nHists) reqInfo.number = run.runHdr.nHists - 1;
      iH.histNumber = reqInfo.number+1;                      // Histogram number

      iH.title = iH.runNumber + ": " + run.runHdr.title
	  + " [H" + run.hist[reqInfo.number].histNumber
	  + ": \"" + run.hist[reqInfo.number].title + "\"]"; // Full Run Title
      iH.label = run.hist[reqInfo.number].title; // Histogram subtitle

// Make sure the user interface subtracts 1 from "bin range" values too!
      if (reqInfo.firstBin>=run.hist[reqInfo.number].bin.length) reqInfo.firstBin = 0;
      if (reqInfo.lastBin>=run.hist[reqInfo.number].bin.length) reqInfo.lastBin = run.hist[reqInfo.number].bin.length - 1;
      if (run.runHdr.fmtID == 0x02010000) {  // for TD runs
	  if (reqInfo.firstBin<0) reqInfo.firstBin = 0;
	  if (reqInfo.lastBin<0) reqInfo.lastBin = run.hist[reqInfo.number].goodBin2 - 1;
      }
      else if (run.runHdr.fmtID == 0x02020000) {  // for TI runs
// NOTE: TI mode "hists" are NOT REALLY HISTOGRAMS but plain integer arrays!
// Nevertheless we shall use "Hist" methods to manipulate them here.
// Just don't get this mixed up in any external procedures!
    if (reqInfo.firstBin == 0 && reqInfo.lastBin == 0)
    {
       reqInfo.firstBin=0;
       reqInfo.lastBin=(int)run.hist[reqInfo.number].nBins-1;
    }
	  if (reqInfo.firstBin<0) reqInfo.firstBin = 0;
	  if (reqInfo.lastBin<0) reqInfo.lastBin = (int)run.hist[reqInfo.number].nBins - 1;
      }
      if (reqInfo.lastBin<reqInfo.firstBin) reqInfo.lastBin = reqInfo.firstBin;

      // iH.nBins = number of bins in this (packed) histogram:
      iH.nBins = reqInfo.lastBin - reqInfo.firstBin + 1;
      if ( reqInfo.packing <= 0 ) {
	  if ( iH.nBins <= 256 ) {
	      reqInfo.packing = 1;
	  }
	  else {
	    reqInfo.packing = (int)((double)(iH.nBins)/(double)(256) + 0.5);
	  }
      }
      if ( reqInfo.packing > 1 ) {
	iH.nBins = (int)((double)(iH.nBins)/(double)(reqInfo.packing));
	int j2t = reqInfo.firstBin + reqInfo.packing*iH.nBins;
	if (j2t>reqInfo.lastBin) iH.nBins = iH.nBins - (int)(0.998 + (j2t-reqInfo.lastBin)/reqInfo.packing);
      }
      iH.bkgdPerBin = 0.0;  // est. Background per packed bin
      if (run.runHdr.fmtID == 0x02010000) {  // for TD runs only!
	int Nb = 0; // Calculate the Background per packed bin:
	for (int i=run.hist[reqInfo.number].bkgd1-1; i<=run.hist[reqInfo.number].bkgd2-1; i++) {
	  Nb = Nb + run.hist[reqInfo.number].bin[i];
	}
	iH.bkgdPerBin = (double)(run.hist[reqInfo.number].bkgd2 - run.hist[reqInfo.number].bkgd1 + 1);
	iH.bkgdPerBin = (double)Nb/iH.bkgdPerBin; // t<0 Background per raw bin
	iH.bkgdPerBin = iH.bkgdPerBin*(double)reqInfo.packing; // est. Background per packed bin
      }

      iH.nsPerBin = ((double)(reqInfo.packing*run.hist[reqInfo.number].nsPerBin)); // ns per packed bin

      iH.t1_ns = (double)(reqInfo.firstBin - 1)*run.hist[reqInfo.number].nsPerBin;
      iH.t1_ns = iH.t1_ns - run.hist[reqInfo.number].t0_ns;
      iH.t1_ns = iH.t1_ns + 0.5*iH.nsPerBin; // time @ centre of 1st packed bin [ns]
      iH.t2_ns = (double)(iH.nBins-1)*iH.nsPerBin;
      iH.t2_ns = iH.t1_ns + iH.t2_ns; // time @ centre of last packed bin [ns]
      pbin = new int[( iH.nBins+1)]; // Kludge to stop ArrayIndexOutOfBoundsException

      iH.nEvents = 0; // total number of events in Histogram
      int jp = 0; int jr = (int)reqInfo.firstBin; int ip = 0;
      pbin[jp] = 0;
      while ((jp<iH.nBins) && (jr<=reqInfo.lastBin)) {
//System.out.println("jp: "+jp);
        pbin[jp] = pbin[jp] + run.hist[reqInfo.number].bin[jr]; ip++;
	      if (ip>=reqInfo.packing) {
	        iH.nEvents = iH.nEvents + pbin[jp];
	        ip = 0; jp++; pbin[jp] = 0;
	      }
	      jr++;
        if (Double.isNaN( (double) pbin[jp] )) {
          ((GUI)parent).popAlertDialog("Warning: ", "one of your histograms contains NaN values, this may cause the Spectrum to load improperly", "");
          break;
        }

//System.out.println("pbin[jp]: "+pbin[jp]);
      }
      // Assign packing value to iH so that it can be retireved later in MUDSpectrumFrame
      iH.packing = reqInfo.packing;

      iH.nnn = new PoissonDataColumn( "N", // Data goes here.
                                                          iH.title,
                                                          "Counts per Packed Bin",
                                                           (int)iH.nBins,
                                                           pbin,
                                                           date
                                     );


      // Get X asis:

      if (mudSpectrumFrame.displayChoice.getSelectedItem().equals("(default)")) {
                    // Display in bin:
                    if (mudSpectrumFrame.spectrumChoice.getSelectedItem().equals(new String("Raw Histogram(s)")) ||
                        mudSpectrumFrame.spectrumChoice.getSelectedItem().equals(new String("Early Bins Spectrum")) ||
                        mudSpectrumFrame.spectrumChoice.getSelectedItem().equals(new String("Late Bins Spectrum")) ) {
                          iH.xxx = new LinearColumn( "BIN", // Hist binning only.
				"Bin", "Bin Number",
				reqInfo.firstBin,
				reqInfo.packing,
				iH.nBins,
                                                                                        date);
                    // Display in ns:
                    } else if (iH.t2_ns<1000) {
                      iH.xxx = new LinearColumn( "T", // Hist binning only.
				"Time", "ns",
				iH.t1_ns,
				iH.nsPerBin,
				iH.nBins,
                                                                                        date);
                    // Display in s
                    } else {
                        iH.xxx = new LinearColumn( "T", // Hist binning only.
				"Time", "s",
				iH.t1_ns*0.001,
				iH.nsPerBin*0.001,
				iH.nBins,
                                                                                        date);
                    }
      }

      else if (mudSpectrumFrame.displayChoice.getSelectedItem().equals(new String("Time [s]")))
        iH.xxx = new LinearColumn( "T", // Hist binning only.
				"Time", "s",
				iH.t1_ns*0.001,
				iH.nsPerBin*0.001,
				iH.nBins,
                                                                                        date);
      else if (mudSpectrumFrame.displayChoice.getSelectedItem().equals(new String("Time [ns]")))
        iH.xxx = new LinearColumn( "T", // Hist binning only.
				"Time", "ns",
				iH.t1_ns,
				iH.nsPerBin,
				iH.nBins,
                                                                                        date);
      else if (mudSpectrumFrame.displayChoice.getSelectedItem().equals(new String("bin #")))
        iH.xxx = new LinearColumn( "BIN", // Hist binning only.
				"Bin", "Bin Number",
				reqInfo.firstBin,
				reqInfo.packing,
				iH.nBins,
                                                                                        date);

    }

    catch (Exception e) {
      //      System.out.println("iHistPack error: "+e);
      //      System.out.println("iHistPack error for "
      System.out.println("iHistPack error for " +fnm
			 +" H#" +(reqInfo.number+1)+"(" +(reqInfo.firstBin+1) +"," +(reqInfo.lastBin+1) +")/" +reqInfo.packing );
			 //			 +" at jp="+jp+", jr="+jr+", ip="+ip
      e.printStackTrace();
    }

    /*
    catch (MuSR_Exception e) {
      System.out.println("iHistPack error: "+e);
      //      System.exit(1);
    }
    */

    return iH;

  }

}
